/* $Id: iterator.h 3 2007-07-09 07:59:45Z romain $ */

#ifndef _ITERATOR_H
#define _ITERATOR_H

struct iterator {
  char *name;

  int start;
  int has_stop;
  int stop;
  int stride;
  int value;
  char *format;

  struct iterator *prev;
  struct iterator *next;
};

typedef struct iterator *Iterator;

Iterator iterator_new(char *iteration_domain);
int iterator_initialize(void);
void iterator_finalize(void);
Iterator iterator_delete(Iterator I);
void iterator_insert_after(Iterator I, Iterator new);
void iterator_iterate(Iterator I, char *cmd, int *error);

#endif /* _ITERATOR_H */
